/*
 * This file is part of XFellow
 *
 * interface.h - Definitions for GUI elements that need to be accessed elsewhere
 * Copyright 2001 by Dan Sutherland <dan@dillinja.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifndef INTERFACE_H
#define INTERFACE_H

GtkWidget* create_winConf(void);
GtkWidget* create_winMain(void);
GtkWidget* create_winAbout(void);
GtkWidget* create_winFilesysConf(void);
GtkWidget* create_winHardfileCreate(void);

/* ----- main window ----- */
GtkWidget *txtDF0;
GtkWidget *txtDF1;
GtkWidget *txtDF2;
GtkWidget *txtDF3;

/* ----- config window ----- */
/* cpu page */
GtkWidget *radCPU68000;
GtkWidget *radCPU68010;
GtkWidget *radCPU68020;
GtkWidget *radCPU68030;
GtkWidget *radCPU68EC20;
GtkWidget *radCPU68EC30;
GtkWidget *radSpeed35;
GtkWidget *radSpeed7;
GtkWidget *radSpeed14;
GtkWidget *radSpeed28;

/* floppy page */
GtkWidget *txtConfDF0;
GtkWidget *txtConfDF1;
GtkWidget *txtConfDF2;
GtkWidget *txtConfDF3;
GtkWidget *chkImgEnabled0;
GtkWidget *chkImgEnabled1;
GtkWidget *chkImgEnabled2;
GtkWidget *chkImgEnabled3;
GtkWidget *chkImgRO0;
GtkWidget *chkImgRO1;
GtkWidget *chkImgRO2;
GtkWidget *chkImgRO3;
GtkWidget *chkFastDiskDMA;

/* memory page */
GtkWidget *txtMemChipEntry;
GtkWidget *txtMemFastEntry;
GtkWidget *txtMemBogoEntry;
GtkWidget *txtKickImage;
GtkWidget *txtKickKey;

/* sound page */
GtkWidget *radSndEmuNo;
GtkWidget *radSndEmuPlay;
GtkWidget *radSndEmuSilent;
GtkWidget *radFilterOrig;
GtkWidget *radFilterAlways;
GtkWidget *radFilterNever;
GtkWidget *radSamRate44100;
GtkWidget *radSamRate31300;
GtkWidget *radSamRate22050;
GtkWidget *radSamRate15650;
GtkWidget *radChanStereo;
GtkWidget *radChanMono;
GtkWidget *chkSoundStreamWAV;
GtkWidget *radBits16;
GtkWidget *radBits8;

/* screen page */
GtkWidget *txtResolutionEntry;
GtkWidget *txtFrameSkipEntry;
GtkWidget *radVScaleSingle;
GtkWidget *radVScaleDouble;
GtkWidget *radVScaleScan;
GtkWidget *chkVScaleIntComp;
GtkWidget *radHScaleSingle;
GtkWidget *radHScaleDouble;
GtkWidget *chkBlitImmediate;
GtkWidget *chkBlitECS;

/* filesystems page */
// missing list

/* hardfile page */
// missing list

/* gameport page */
GtkWidget *txtGameport1Entry;
GtkWidget *txtGameport2Entry;

/* misc page */
GtkWidget *chkGenShowFPS;
GtkWidget *chkGenShowLED;
GtkWidget *chkDisableAutoconf;

#endif /* ndef INTERFACE_H */
