#ifndef PORTABLE_H
#define PORTABLE_H


/*====================================================*/
/* Wrapper definitions for system dependent functions */
/* Linux, glibc                                       */
/*====================================================*/

/*=======*/
/* stdio */
/*=======*/

#include <stdio.h>

// this defines errno
#include <errno.h>

/*================================*/
/* stat structure and field names */
/*================================*/

#include <sys/stat.h>

/*=====================*/
/* string manipulation */
/*=====================*/

#include <string.h>

#define stricmp strcasecmp
#define _stricmp strcasecmp
#define strcmpi strcasecmp
#define _vsnprintf vsnprintf

/*====================================*/
/* memory manipulation and allocation */
/*====================================*/

#include <memory.h>
#include <stdlib.h>

/* glib is needed for va_list et al */
#include <glib.h>
#include <SDL/SDL.h>

/*========*/
/* setjmp */
/*========*/

#include <setjmp.h>


/*=====================*/
/* Integer types       */
/*=====================*/

#define FELLOW_LONG_LONG long long

#define _strdup strdup

/* xDMS uses but doesn't define this - maybe a Windows/DOS thing? */
#define USHORT unsigned short

#endif /* PORTABLE_H */

